//+------------------------------------------------------------------+
//|                                               jealousy_levels_v2 |
//|                                Copyright  2009, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Victor Nicolaev"
#property link      "e-mail: vinin@mail.ru"


//===================================================================
extern string  S1             = " ";
extern string  IndicatorName  ="jealousy_levels_v2";


extern string  S2             = " MM";
extern double  Lots           =        0.1;
extern double  Risk           =        1.0;
extern int     MaxCountOrder  =        1;


extern int     StopLoss       =      30;              //  


extern int     TakeProfit     =   32;              //  

extern string  S3             = " ";
extern int     HourStart         =0;
extern int     HourStop          =24;


extern int     Magic          = 20091208;
extern string  _comment       = "  ;-)"; //  

       color   clOpenBuy      = Red; 
       color   clOpenSell     = Blue;
       color   clCloseBuy     = Red; 
       color   clCloseSell    = Blue;


int Order_Count[6];
string   NameOP[]={"BUY","SELL","BUYLIMMIT","SELLLIMIT","BUYSTOP","SELLSTOP"};


#include <stdlib.mqh>
#include <WinUser32.mqh>


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {//0
   GetLastError();         //   
   //if (IsVisualMode()) HideTestIndicators(true); //      
return(0);}//0


//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0); 
}

int start() { 
   if (!NevBar()) return(0);
   if (!CheckHour()) return(0);
   
   int cmd=CheckSignal();

   if (cmd==-1 ) return(0);
   SetOrder(Symbol(),Magic,cmd);  //SetOrder()     , 
                                  //       
                                  //   ,  
   return(0);
   
} 

int CheckSignal(){
   int res=-1;

  double in0=iCustom(NULL,0,IndicatorName,0,1); 
  double in1=iCustom(NULL,0,IndicatorName,1,1); 
  
   if(in0>0) res=OP_SELL; //  
   if(in1>1) res=OP_BUY; //  
   return(res);
}

bool SetOrder(string lsSymbol, int lnMagic, int OP){
   bool Res=false;
   int cmd=MathAbs(OP-1);
   Order_Count_Calculate();          //      
   if (Order_Count[cmd]>0)             //    
      Order_Close(lsSymbol, lnMagic, cmd);
   if (Order_Count[OP]<MaxCountOrder)             //    
      Order_Open( lsSymbol, lnMagic, OP);
   return(Res);
}

bool NevBar() {
   static int PrevBar=0;
   int NevBar=Time[0];
   if (PrevBar==NevBar) return(false);
   PrevBar=NevBar;
   return(true);
}


///======================================================================================================
//   
//=====================================================================================================
double iif(bool A, double B, double C) {if(A) return(B); return(C); }

//======================================================================================================
//   
//=====================================================================================================
void Order_Open(string lsSymbol, int lnMagic, int OP){
   int err=GetLastError();
   double Slippage=(Ask-Bid)/Point;
   RefreshRates();
   

   int cmd=iif(OP==OP_BUY,1,-1);
   double _ask     =MarketInfo(lsSymbol,MODE_ASK);
   double _bid     =MarketInfo(lsSymbol,MODE_BID);
   double _point   =MarketInfo(lsSymbol,MODE_POINT);
   double _digits  =MarketInfo(lsSymbol,MODE_DIGITS);
   double price= iif(OP==OP_BUY==0,_ask,_bid);
   double _sl=NormalizeDouble(iif(StopLoss==0,0,price-cmd*StopLoss*_point),_digits);
   double _tp=NormalizeDouble(iif(TakeProfit==0,0,price+cmd*TakeProfit*_point),_digits);
   double lots=GetLots();      

   OrderSend(lsSymbol, OP,  lots, price, Slippage,_sl,_tp,_comment,lnMagic, 0); 
   err=GetLastError();
   if (err>0) Print(Ask," ;", Bid, " ;", price," ;",_sl," ;",_tp);

}
void Order_Close(string lsSymbol="", int lnMagicNumber=0, int OP=-1){
   bool res;
   double Slippage=(Ask-Bid)/Point;
   GetLastError();
   if (lsSymbol=="") lsSymbol=Symbol();
   for(int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!CheckOrder(i, lsSymbol, lnMagicNumber))  continue;
      if (OrderType()!=OP && OP!=-1)               continue;
      
      RefreshRates();
      
      double dlAsk     = MarketInfo(lsSymbol,MODE_ASK);
      double dlBid     = MarketInfo(lsSymbol,MODE_BID);
      double dlPoint   = MarketInfo(lsSymbol,MODE_POINT);
      double dlDigits  = MarketInfo(lsSymbol,MODE_DIGITS);
      double dlPrice   = NormalizeDouble(iif(OrderType()==OP_BUY,dlBid, dlAsk),dlDigits);
      res=OrderClose(OrderTicket(), OrderLots(), dlPrice, Slippage, iif(OrderType()==OP_BUY,clCloseBuy,clCloseSell));
      if (!res) {
         int err=GetLastError();
         Print("Error(",err,") delete order ",NameOP[OP],": ",ErrorDescription(err));
      }
   }
}

//===============================================================================
//          
//===============================================================================
int Order_Count_Calculate(string lsSymbol="", int lnMagicNumber=-1, int OP=-1){
   ArrayInitialize(Order_Count,0);
   for (int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!CheckOrder(i, lsSymbol, lnMagicNumber))  continue;
      if (OrderType()!=OP && OP!=-1)                continue;
      Order_Count[OrderType()]++;
   }
   if (OP!=-1) return(Order_Count[OP]);
}

//===============================================================================
//         
//
//===============================================================================
double GetLots() {
   double LotMin=MarketInfo(Symbol(),MODE_MINLOT);
   double LotMax=MarketInfo(Symbol(),MODE_MAXLOT);
   double LotStep=MarketInfo(Symbol(),MODE_LOTSTEP);
   double lot=MathRound(Lots/LotStep)*LotStep;
   
   if (Risk>0) {
      lot=MathCeil(AccountFreeMargin()/MarketInfo(Symbol(),MODE_MARGINREQUIRED)/100.0*Risk/LotStep)*LotStep;
   }
   
   lot=MathMax(LotMin,MathMin(LotMax,lot));
   
   return(lot); 
}

bool CheckOrder(int lnPos,string lsSymbol="", int lnMagicNumber=-1) {
   if (!OrderSelect(lnPos,SELECT_BY_POS))           return(false);
   if (!(OrderSymbol()==lsSymbol || lsSymbol==""))  return(false);
   if (!(OrderMagicNumber()==lnMagicNumber || lnMagicNumber==-1))   return(false);
   return(true);
}

bool CheckHour(){
   int Hourtmp=TimeHour(Time[0]);
   if (HourStart==-1 || HourStop==-1) return(true);
   if (HourStart==HourStop && Hourtmp==HourStart) return(true);
   if (HourStart<HourStop) {
      if (Hourtmp>=HourStart && Hourtmp<=HourStop) return(true);
      return(false);
   }
   if (HourStart>HourStop) {
      if (Hourtmp>=HourStart || Hourtmp<=HourStop) return(true);
      return(false);
   }

}


